module QRAPI
  class Distribution < BaseModel
    attribute :id
    attribute :parent_distribution_id
    attribute :owner_id
    attribute :organization_id
    attribute :request_status
    attribute :request_type
    attribute :send_date
    attribute :created_date
    attribute :modified_date
    attribute :headers
    attribute :recipients
    attribute :message
    attribute :survey_link
    attribute :stats

    ##
    # Make the model serializeable by ActiveModelSerializer
    #
    # @return [OpenStruct]
    #
    def self.model_name
      OpenStruct.new(name: "QRAPI::Distribution",
                     klass: self,
                     singular: "qualtrics_distribution",
                     plural: "qualtrics_distributions",
                     element: "distribution",
                     human: "distribution",
                     collection: "qrapi/distributions",
                     param_key: "qualtrics_distributions",
                     i18n_key: "qrapi/distributions",
                     route_key: "qualtrics_distributions",
                     singular_route_key: "qualtrics_distribution")
    end

    def created_at
      creation_date
    end

    def updated_at
      modified_date
    end
  end
end
