module QRAPI
  class Response < BaseModel
    include ::ActiveModel::Serialization

    attribute :id
    attribute :response_set
    attribute :ip_address
    attribute :start_date
    attribute :end_date
    attribute :last_name
    attribute :first_name
    attribute :email
    attribute :external_data_reference
    attribute :finished
    attribute :status
    attribute :location_latitude
    attribute :location_longitude
    attribute :location_accuracy
    attribute :questions

    ##
    # Make the model serializeable by ActiveModelSerializer
    #
    # @return [OpenStruct]
    #
    def self.model_name
      OpenStruct.new(name: "QRAPI::Response",
                     klass: self,
                     singular: "qualtrics_response",
                     plural: "qualtrics_responses",
                     element: "responses",
                     human: "response",
                     collection: "qrapi/responses",
                     param_key: "qualtrics_responses",
                     i18n_key: "qrapi/responses",
                     route_key: "qualtrics_responses",
                     singular_route_key: "qualtrics_response")
    end
  end
end
